<?php
/*
Plugin Name: Quick admin color scheme picker
Author: mitcho (Michael 芳貴 Erlewine)
Description: Lets you quickly switch between admin color schemes from the "howdy menu." Happy Birthday Sara Cannon!
Version: 0.1
*/

add_action('admin_user_info_links', 'qacsp_link', 10, 1000);
function qacsp_link( $links, $user_id ) {
	global $_wp_admin_css_colors;
	
	$current_color = get_user_option('admin_color', $user_id->ID);
	if ( empty($current_color) )
		$current_color = 'fresh';
		
	$colorlinks = array();
	
	foreach ( $_wp_admin_css_colors as $color => $color_info ) {
		$url = add_query_arg( 'admin_color', $color, $_SERVER['REQUEST_URI'] );
		$colorlink = '<a href="' . $url . '">';
		
		// add checkmark for current color
		$colorlink .= ($color == $current_color) ? '✔ ' : '　 ';

		// print colors
		foreach ( $color_info->colors as $html_color ) {
			$colorlink .= '<span style="width: 10px; height: 10px; display: inline-block; background-color: ' . $html_color . '" title="' . $color . ' ">&nbsp;</span>';
		}
		$colorlink .= ' ' . $color_info->name . '</a>';
		$colorlinks[] = $colorlink;
	}

	// add colors after the "your profile" link, which has key 5.
	$links = array_merge(array_splice($links, 0, array_search(5,$links) + 1), $colorlinks, array_splice($links, array_search(5,$links)));
	
	return $links;
}

add_action('admin_init', 'qacsp_switch');
function qacsp_switch() {
	if ( !isset( $_GET['admin_color'] ) )
		return;

	if ( ! $user = wp_get_current_user() )
		die('-1');

	update_user_option( $user->ID, 'admin_color', sanitize_text_field( $_GET['admin_color'] ) );
	wp_redirect( remove_query_arg( 'admin_color', $_SERVER['REQUEST_URI'] ) );
}

//admin_color_scheme_picker